#!/bin/sh
#
# $Copyright (c) 2017 Veritas Technologies LLC.  All rights reserved. Veritas
# and the Veritas Logo are trademarks or registered trademarks of Veritas
# Technologies LLC or its affiliates in the U.S. and other countries. Other 
# names may be trademarks of their respective owners.
# 
# The Licensed Software and Documentation are deemed to be commercial computer
# software as defined in FAR 12.212 and subject to restricted rights as defined
# in FAR Section 52.227-19 "Commercial Computer Software - Restricted Rights" and
# DFARS 227.7202, et seq. "Commercial Computer Software and Commercial Computer
# Software Documentation," as applicable, and any successor regulations, whether
# delivered by Veritas as on premises or hosted services. Any use, modification,
# reproduction release, performance, display or disclosure of the Licensed Software
# and Documentation by the U.S. Government shall be solely in accordance with the
# terms of this Agreement. $
# $Revision: ee2a3920aad9aafc36fbaa94d7a292f364a68ae6 $
# $Source: src/htc/unix/addHTCType.sh $
#

add_fun(){
result="`$@ 2>&1`"
if [ $? -eq 1 ]; then
    if [ `echo "$result" | grep -c "already exist"` -eq 1 ]; then
        :
    else
        echo "$@";
    fi
fi
}

VCSHOME="${VCS_HOME:-/opt/VRTSvcs}"
ro=`${VCSHOME}/bin/haclus -value ReadOnly`
if [ $? -eq 0 ]; then
    if [ "$ro" -eq 1 ];
    then
        ${VCSHOME}/bin/haconf -makerw
    fi
else
    echo "Unable to add the HTC and HTCSnap types, VCS is not running. Start VCS and execute the script /etc/VRTSvcs/conf/sample_htc/addHTCType.sh "
    exit 0;
fi

add_fun "${VCSHOME}/bin/hatype -add HTC"
${VCSHOME}/bin/hatype -modify HTC SupportedActions localtakeover pairresync pairresync-swaps pairdisplay vxdiske PreSwitch ReportRPOData StartWriter GetCurrentRPO StartRPOComputation StopRPOComputation updatePVOLState vxvm_rescan
${VCSHOME}/bin/hatype -modify HTC InfoInterval 300
${VCSHOME}/bin/hatype -modify HTC OpenTimeout 180
${VCSHOME}/bin/hatype -modify HTC ArgList BaseDir GroupName Instance SplitTakeover LinkMonitor RoleMonitor FreezeSecondaryOnSplit AllowOnlineOnSimplex ComputeDRSLA AdvancedOpts
add_fun "${VCSHOME}/bin/haattr -add HTC BaseDir -string \"/HORCM/usr/bin\""
add_fun "${VCSHOME}/bin/haattr -add HTC GroupName -string"
add_fun "${VCSHOME}/bin/haattr -add HTC Instance -integer"
add_fun "${VCSHOME}/bin/haattr -add HTC SplitTakeover -integer"
add_fun "${VCSHOME}/bin/haattr -add HTC LinkMonitor -integer"
add_fun "${VCSHOME}/bin/haattr -add HTC RoleMonitor -integer"
add_fun "${VCSHOME}/bin/haattr -add HTC FreezeSecondaryOnSplit -integer"
add_fun "${VCSHOME}/bin/haattr -add HTC AllowOnlineOnSimplex -boolean 0"
add_fun "${VCSHOME}/bin/haattr -add -temp HTC VCSResLock -string"
add_fun "${VCSHOME}/bin/haattr -add -temp HTC TargetFrozen -string"
add_fun "${VCSHOME}/bin/haattr -add HTC ComputeDRSLA -integer 0"
add_fun "${VCSHOME}/bin/haattr -add -temp HTC Tagging -boolean"
add_fun "${VCSHOME}/bin/haattr -add -static HTC RegList -keylist"
add_fun "${VCSHOME}/bin/haattr -add HTC AdvancedOpts -string -assoc AllowAutoFailoverInterval %-1 "
add_fun "${VCSHOME}/bin/haattr -add -temp HTC  PVOLStateTime  -string """
${VCSHOME}/bin/hatype -modify HTC RegList ComputeDRSLA SplitTakeover LinkMonitor RoleMonitor FreezeSecondaryOnSplit AllowOnlineOnSimplex

add_fun "${VCSHOME}/bin/hatype -add HTCSnap"
${VCSHOME}/bin/hatype -modify HTCSnap SupportedActions clearvm
${VCSHOME}/bin/hatype -modify HTCSnap ArgList TargetResName MountSnapshot UseSnapshot RequireSnapshot ShadowInstance
${VCSHOME}/bin/hatype -modify HTCSnap OpenTimeout 180
add_fun "${VCSHOME}/bin/haattr -add HTCSnap TargetResName -string"
add_fun "${VCSHOME}/bin/haattr -add HTCSnap ShadowInstance -integer"
add_fun "${VCSHOME}/bin/haattr -add HTCSnap MountSnapshot -integer 1"
add_fun "${VCSHOME}/bin/haattr -add HTCSnap UseSnapshot -integer 1"
add_fun "${VCSHOME}/bin/haattr -add HTCSnap RequireSnapshot -integer 1"
add_fun "${VCSHOME}/bin/haattr -add -temp HTCSnap Responsibility -string"
add_fun "${VCSHOME}/bin/haattr -add -temp HTCSnap FDFile -string"
add_fun "${VCSHOME}/bin/haattr -add -temp HTCSnap VCSResLock -string"
add_fun "${VCSHOME}/bin/haattr -add -static HTCSnap RegList -keylist MountSnapshot UseSnapshot"

out=`${VCSHOME}/bin/hatype -list | grep CVMVolDg`
if [ -z "$out" ]
then
        echo "NOTICE : Could not find the VCS resource type CVMVolDg."
        echo "         If you intend to use HTC with CVM, please modify the type definition for"
        echo "         a. CVMVolDg to include import and deport in the list of supported actions after."
        echo "            the CVMVolDg agent is installed."
        echo "         b. Change the value of 'ActionTimeout' to 300"
        echo ""
        echo "         This can be done by adding the following statement to the CVMTypes.cf file -"
        echo "         static keylist SupportedActions = { vxdctlenable }"
        echo "         static int ActionTimeout = 300"
        echo ""
        echo "         If the attribute SupportedActions is already defined in the types definition"
        echo "         please add 'vxdctlenable' to the list of actions already specified."

else
    ${VCSHOME}/bin/hatype -modify CVMVolDg SupportedActions vxdctlenable
    ${VCSHOME}/bin/hatype -modify CVMVolDg ActionTimeout 300
fi

if [ $ro -eq 1 ];
then
        ${VCSHOME}/bin/haconf -dump -makero
else
        ${VCSHOME}/bin/haconf -dump
fi
